<h1 align="center">rc-ui-lib</h1>

<p align="center">参照 <a href="https://github.com/youzan/vant">Vant</a> 打造的 React 框架移动端组件库。</p>

<p align="center">
  🌈 <a href="https://rancui.github.io/rc-ui-lib/">文档网站（GitHub）</a>
</p>

## 特性

- 提供 50 多个高质量组件，覆盖移动端各类场景
- 性能极佳，组件平均体积不到 1kb（min+gzip）
- 完善的文档和示例
- 支持按需引入
- 支持主题定制(less modifyVars)
- 支持 TypeScript
- 支持 SSR
- 支持 Vite

## 安装

[![rc-ui-lib](https://nodei.co/npm/rc-ui-lib.png)](https://npmjs.org/package/rc-ui-lib)

## 快速开始

```jsx
import ReactDOM from 'react-dom';
import { Button } from 'rc-ui-lib';
import 'rc-ui-lib/lib/index.css';

function App() {
  return <Button>Default Button</Button>;
}

ReactDOM.render(<App />, mountNode);
```

## 浏览器支持

rc-ui-lib 支持现代浏览器以及 Chrome >= 51、iOS >= 10.0。

## 贡献代码

修改代码请阅读我们的 [贡献指南](https://rancui.github.io/rc-ui-lib/#/zh-CN/contribution)。

使用过程中发现任何问题都可以提 [Issue](https://github.com/rancui/rc-ui-lib/issues) 给我们，当然，我们也非常欢迎你给我们发 [PR](https://github.com/rancui/rc-ui-lib/pulls)。
