import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React from 'react';
import { mount } from 'enzyme';
import toJson from 'enzyme-to-json';
import Badge from '../index';
import Icon from '../../icon';
it('should render nothing when content is empty string', function () {
  var wrapper = mount( /*#__PURE__*/React.createElement(Badge, {
    content: ""
  }));
  expect(toJson(wrapper)).toMatchSnapshot();
});
it('should render nothing when content is undefined', function () {
  var wrapper = mount( /*#__PURE__*/React.createElement(Badge, {
    content: "undefined"
  }));
  expect(toJson(wrapper)).toMatchSnapshot();
});
it('should render nothing when content is zero', function () {
  var wrapper = mount( /*#__PURE__*/React.createElement(Badge, {
    content: "0"
  }));
  expect(toJson(wrapper)).toMatchSnapshot();
});
it('should render content slot correctly', function () {
  var wrapper = mount( /*#__PURE__*/React.createElement(Badge, {
    content: /*#__PURE__*/React.createElement(Icon, {
      name: "success",
      className: "badge-icon"
    })
  }, /*#__PURE__*/React.createElement("div", {
    className: "child"
  })));
  expect(toJson(wrapper)).toMatchSnapshot();
});
it('should change dot position when using offset prop', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
  var wrapper, badge;
  return _regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          wrapper = mount( /*#__PURE__*/React.createElement(Badge, {
            dot: true,
            offset: [2, 4]
          }, /*#__PURE__*/React.createElement("div", {
            className: "child"
          })));
          badge = wrapper.find('.rc-badge');
          expect(badge.props().style.top).toEqual('4px');
          expect(badge.props().style.right).toEqual('-2px');
          _context.next = 6;
          return wrapper.setProps({
            offset: [-2, -4]
          });

        case 6:
          expect(wrapper.find('.rc-badge').props().style.top).toEqual('-4px');
          expect(wrapper.find('.rc-badge').props().style.right).toEqual('2px');

        case 8:
        case "end":
          return _context.stop();
      }
    }
  }, _callee);
})));
it('should change dot position when using offset prop with custom unit', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
  var wrapper, badge;
  return _regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          wrapper = mount( /*#__PURE__*/React.createElement(Badge, {
            dot: true,
            offset: ['2rem', '4em']
          }, /*#__PURE__*/React.createElement("div", {
            className: "child"
          })));
          badge = wrapper.find('.rc-badge');
          expect(badge.getDOMNode().style.top).toEqual('4em');
          expect(badge.getDOMNode().style.right).toEqual('-2rem');
          _context2.next = 6;
          return wrapper.setProps({
            offset: ['-2rem', '-4em']
          });

        case 6:
          expect(wrapper.find('.rc-badge').props().style.top).toEqual('-4em');
          expect(wrapper.find('.rc-badge').props().style.right).toEqual('2rem');

        case 8:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2);
})));
it('should change dot position when using offset prop without children', function () {
  var wrapper = mount( /*#__PURE__*/React.createElement(Badge, {
    dot: true,
    offset: [2, 4]
  }));
  var badge = wrapper.find('.rc-badge');
  expect(badge.props().style.marginTop).toEqual('4px');
  expect(badge.props().style.marginLeft).toEqual('2px');
});
it('should not render zero when show-zero is false', /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
  var wrapper;
  return _regeneratorRuntime.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          wrapper = mount( /*#__PURE__*/React.createElement(Badge, {
            content: "0"
          }, /*#__PURE__*/React.createElement("div", {
            className: "child"
          })));
          expect(wrapper.find('.rc-badge').exists()).toBeTruthy();
          _context3.next = 4;
          return wrapper.setProps({
            showZero: false
          });

        case 4:
          expect(wrapper.find('.rc-badge').exists()).toEqual(false);

        case 5:
        case "end":
          return _context3.stop();
      }
    }
  }, _callee3);
})));
it('can set custom max count', function () {
  var wrapper = mount( /*#__PURE__*/React.createElement(Badge, {
    content: 100,
    max: 99
  }, "news"));
  expect(wrapper.find('.rc-badge').text()).toBe('99+');
});