import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { useState } from 'react';
import { inBrowser } from '../utils';
import useEventListener from './use-event-listener';

function useWindowSize() {
  var _useState = useState(inBrowser ? window.innerWidth : 0),
      _useState2 = _slicedToArray(_useState, 2),
      width = _useState2[0],
      setWidth = _useState2[1];

  var _useState3 = useState(inBrowser ? window.innerHeight : 0),
      _useState4 = _slicedToArray(_useState3, 2),
      height = _useState4[0],
      setHeight = _useState4[1];

  var onResize = function onResize() {
    setWidth(window.innerWidth);
    setHeight(window.innerHeight);
  };

  useEventListener('resize', onResize);
  useEventListener('orientationchange', onResize);
  return {
    width: width,
    height: height
  };
}

export default useWindowSize;