import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
var _excluded = ["parent"];
import React, { useContext, useMemo } from 'react';
import RadioContext from './RadioContext';
import Checker from '../checkbox/Checker';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';

var Radio = function Radio(props) {
  var _useContext = useContext(ConfigProviderContext),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('radio', prefixCls),
      _createNamespace2 = _slicedToArray(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _useContext2 = useContext(RadioContext),
      parent = _useContext2.parent,
      context = _objectWithoutProperties(_useContext2, _excluded);

  var checked = useMemo(function () {
    return parent ? context.checked === props.name : props.checked;
  }, [context.checked]);

  var toggle = function toggle() {
    var emitter = parent ? context.toggle : function () {};
    emitter(props.name);
  };

  return /*#__PURE__*/React.createElement(Checker, _extends({}, props, {
    bem: bem,
    role: "radio",
    parent: parent,
    checked: checked,
    onToggle: toggle
  }));
};

export default Radio;