import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["children", "className", "style"];
import React, { useContext } from 'react';
import cls from 'classnames';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';

var Steps = function Steps(_ref) {
  var children = _ref.children,
      className = _ref.className,
      style = _ref.style,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useContext = useContext(ConfigProviderContext),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('steps', prefixCls),
      _createNamespace2 = _slicedToArray(_createNamespace, 1),
      bem = _createNamespace2[0];

  return /*#__PURE__*/React.createElement("div", {
    className: cls(className, bem([props.direction])),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: cls(bem('items'))
  }, React.Children.toArray(children).filter(Boolean).map(function (child, index) {
    return /*#__PURE__*/React.cloneElement(child, {
      index: index,
      parent: props
    });
  })));
};

Steps.defaultProps = {
  active: 0,
  direction: 'horizontal',
  activeIcon: 'checked'
};
export default Steps;