import _extends from "@babel/runtime/helpers/esm/extends";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/* eslint-disable no-console */
import React, { useContext, useMemo } from 'react';
import classnames from 'classnames';
import TabbarContext from './TabbarContext';
import { Icon } from '../icon';
import { Badge } from '../badge';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';

var TabbarItem = function TabbarItem(props) {
  var setActive = props.setActive,
      index = props.index;

  var _useContext = useContext(ConfigProviderContext),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('tabbar-item', prefixCls),
      _createNamespace2 = _slicedToArray(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _useContext2 = useContext(TabbarContext),
      parent = _useContext2.parent;

  var activeColor = parent.activeColor,
      inactiveColor = parent.inactiveColor;

  if (!parent) {
    if (process.env.NODE_ENV !== 'production') {
      console.error('[rc-ui-lib] <TabbarItem> must be a child component of <Tabbar>.');
    }
  }

  var active = useMemo(function () {
    return (props.name || index) === parent.value;
  }, [props.name, index, parent.value]);

  var onClick = function onClick(event) {
    var _props$name, _props$onClick;

    setActive((_props$name = props.name) !== null && _props$name !== void 0 ? _props$name : index);
    (_props$onClick = props.onClick) === null || _props$onClick === void 0 ? void 0 : _props$onClick.call(props, event);
  };

  var renderIcon = function renderIcon() {
    if (typeof props.icon === 'string') {
      return /*#__PURE__*/React.createElement(Icon, {
        name: props.icon,
        classPrefix: props.iconPrefix
      });
    }

    if (typeof props.icon === 'function') {
      return props.icon(active);
    }

    return null;
  };

  var color = active ? activeColor : inactiveColor;
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(props.className, bem({
      active: active
    })),
    style: _objectSpread(_objectSpread({}, props.style), {}, {
      color: color
    }),
    onClick: onClick
  }, /*#__PURE__*/React.createElement(Badge, _extends({}, props.badge, {
    className: classnames(bem('icon'))
  }), renderIcon()), /*#__PURE__*/React.createElement("div", {
    className: classnames(bem('text'))
  }, typeof props.children === 'function' ? props.children(active) : props.children));
};

export default TabbarItem;