import _extends from "@babel/runtime/helpers/esm/extends";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["type", "size", "level", "center", "ellipsis", "className", "children", "strong", "underline", "disabled", "renderType", "delete"];
import React, { useContext } from 'react';
import classnames from 'classnames';
import ConfigProviderContext from '../config-provider/ConfigProviderContext';

var TypographyBase = function TypographyBase(_ref) {
  var type = _ref.type,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'md' : _ref$size,
      level = _ref.level,
      center = _ref.center,
      ellipsis = _ref.ellipsis,
      className = _ref.className,
      children = _ref.children,
      strong = _ref.strong,
      underline = _ref.underline,
      disabled = _ref.disabled,
      renderType = _ref.renderType,
      del = _ref.delete,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useContext = useContext(ConfigProviderContext),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('typography', prefixCls),
      _createNamespace2 = _slicedToArray(_createNamespace, 1),
      bem = _createNamespace2[0];

  var elli = ellipsis === true ? 1 : ellipsis;
  return /*#__PURE__*/React.createElement("div", _extends({
    className: classnames(className, bem([type, size, renderType, _defineProperty({
      center: center,
      strong: strong,
      underline: underline,
      disabled: disabled,
      delete: del
    }, "l".concat(level), renderType === 'title' && level)]), _defineProperty({
      'rc-ellipsis': elli === 1
    }, "rc-multi-ellipsis--l".concat(elli), elli && elli > 1))
  }, props), children);
};

export default TypographyBase;