"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _enzyme() {
  var data = require("enzyme");

  _enzyme = function _enzyme() {
    return data;
  };

  return data;
}

function _enzymeToJson() {
  var data = _interopRequireDefault(require("enzyme-to-json"));

  _enzymeToJson = function _enzymeToJson() {
    return data;
  };

  return data;
}

var _index = _interopRequireDefault(require("../index"));

var _icon = _interopRequireDefault(require("../../icon"));

it('should render nothing when content is empty string', function () {
  var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
    content: ""
  }));
  expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
});
it('should render nothing when content is undefined', function () {
  var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
    content: "undefined"
  }));
  expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
});
it('should render nothing when content is zero', function () {
  var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
    content: "0"
  }));
  expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
});
it('should render content slot correctly', function () {
  var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
    content: /*#__PURE__*/_react().default.createElement(_icon.default, {
      name: "success",
      className: "badge-icon"
    })
  }, /*#__PURE__*/_react().default.createElement("div", {
    className: "child"
  })));
  expect((0, _enzymeToJson().default)(wrapper)).toMatchSnapshot();
});
it('should change dot position when using offset prop', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee() {
  var wrapper, badge;
  return _regenerator().default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
            dot: true,
            offset: [2, 4]
          }, /*#__PURE__*/_react().default.createElement("div", {
            className: "child"
          })));
          badge = wrapper.find('.rc-badge');
          expect(badge.props().style.top).toEqual('4px');
          expect(badge.props().style.right).toEqual('-2px');
          _context.next = 6;
          return wrapper.setProps({
            offset: [-2, -4]
          });

        case 6:
          expect(wrapper.find('.rc-badge').props().style.top).toEqual('-4px');
          expect(wrapper.find('.rc-badge').props().style.right).toEqual('2px');

        case 8:
        case "end":
          return _context.stop();
      }
    }
  }, _callee);
})));
it('should change dot position when using offset prop with custom unit', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee2() {
  var wrapper, badge;
  return _regenerator().default.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
            dot: true,
            offset: ['2rem', '4em']
          }, /*#__PURE__*/_react().default.createElement("div", {
            className: "child"
          })));
          badge = wrapper.find('.rc-badge');
          expect(badge.getDOMNode().style.top).toEqual('4em');
          expect(badge.getDOMNode().style.right).toEqual('-2rem');
          _context2.next = 6;
          return wrapper.setProps({
            offset: ['-2rem', '-4em']
          });

        case 6:
          expect(wrapper.find('.rc-badge').props().style.top).toEqual('-4em');
          expect(wrapper.find('.rc-badge').props().style.right).toEqual('2rem');

        case 8:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2);
})));
it('should change dot position when using offset prop without children', function () {
  var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
    dot: true,
    offset: [2, 4]
  }));
  var badge = wrapper.find('.rc-badge');
  expect(badge.props().style.marginTop).toEqual('4px');
  expect(badge.props().style.marginLeft).toEqual('2px');
});
it('should not render zero when show-zero is false', /*#__PURE__*/(0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee3() {
  var wrapper;
  return _regenerator().default.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
            content: "0"
          }, /*#__PURE__*/_react().default.createElement("div", {
            className: "child"
          })));
          expect(wrapper.find('.rc-badge').exists()).toBeTruthy();
          _context3.next = 4;
          return wrapper.setProps({
            showZero: false
          });

        case 4:
          expect(wrapper.find('.rc-badge').exists()).toEqual(false);

        case 5:
        case "end":
          return _context3.stop();
      }
    }
  }, _callee3);
})));
it('can set custom max count', function () {
  var wrapper = (0, _enzyme().mount)( /*#__PURE__*/_react().default.createElement(_index.default, {
    content: 100,
    max: 99
  }, "news"));
  expect(wrapper.find('.rc-badge').text()).toBe('99+');
});