"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _Network = require("./Network");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var PRESET_IMAGES = ['error', 'search', 'default'];

var Empty = function Empty(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('empty', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var renderImage = function renderImage() {
    var image = props.image;

    if ( /*#__PURE__*/(0, _react().isValidElement)(image)) {
      return image;
    }

    if (image === 'network') {
      return _Network.Network;
    }

    if (PRESET_IMAGES.includes(image)) {
      image = "https://img.yzcdn.cn/vant/empty-image-".concat(image, ".png");
    }

    return /*#__PURE__*/_react().default.createElement("img", {
      src: image,
      alt: ""
    });
  };

  var renderDescription = function renderDescription() {
    if (props.description) {
      return /*#__PURE__*/_react().default.createElement("p", {
        className: (0, _classnames().default)(bem('description'))
      }, props.description);
    }

    return null;
  };

  var renderBottom = function renderBottom() {
    if (props.children) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('bottom'))
      }, props.children);
    }

    return null;
  };

  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(props.className, bem()),
    style: props.style
  }, /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('image')),
    style: (0, _utils.getSizeStyle)(props.imageSize)
  }, renderImage()), renderDescription(), renderBottom());
};

Empty.defaultProps = {
  image: 'default'
};
var _default = Empty;
exports.default = _default;