"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _toConsumableArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

  _toConsumableArray2 = function _toConsumableArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = require("react");

  _react = function _react() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

/* eslint-disable react-hooks/rules-of-hooks */

/* eslint-disable @typescript-eslint/no-unused-vars */
// https://developer.mozilla.org/zh-CN/docs/Web/API/EventTarget/addEventListener#使用_passive_改善的滚屏性能
var supportsPassive = false;

if (_utils.inBrowser) {
  try {
    var opts = {};
    Object.defineProperty(opts, 'passive', {
      get: function get() {
        supportsPassive = true;
      }
    });
    window.addEventListener('test-passive', null, opts); // eslint-disable-next-line no-empty
  } catch (e) {}
}

function useEventListener(type, listener) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!_utils.inBrowser) {
    return;
  }

  var _options$target = options.target,
      target = _options$target === void 0 ? window : _options$target,
      _options$passive = options.passive,
      passive = _options$passive === void 0 ? false : _options$passive,
      _options$capture = options.capture,
      capture = _options$capture === void 0 ? false : _options$capture,
      _options$depends = options.depends,
      depends = _options$depends === void 0 ? [] : _options$depends;
  var attached;

  var add = function add() {
    var element = target;

    if (element && !attached) {
      element.addEventListener(type, listener, supportsPassive ? {
        capture: capture,
        passive: passive
      } : capture);
      attached = true;
    }
  };

  var remove = function remove() {
    var element = target;

    if (element && attached) {
      element.removeEventListener(type, listener, capture);
      attached = false;
    }
  }; // https://stackoverflow.com/questions/55265255/react-usestate-hook-event-handler-using-initial-state


  (0, _react().useEffect)(function () {
    add();
    return function () {
      return remove();
    };
  }, [target].concat((0, _toConsumableArray2().default)(depends)));
}

var _default = useEventListener;
exports.default = _default;