"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _loading = _interopRequireDefault(require("../loading"));

var _useRect = require("../hooks/use-rect");

var _useScrollParent = _interopRequireDefault(require("../hooks/use-scroll-parent"));

var _useEventListener = _interopRequireDefault(require("../hooks/use-event-listener"));

var _utils = require("../utils");

var _hooks = require("../hooks");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var List = /*#__PURE__*/(0, _react().forwardRef)(function (props, ref) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('list', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _useSetState = (0, _hooks.useSetState)({
    loading: props.loading,
    error: props.error
  }),
      _useSetState2 = (0, _slicedToArray2().default)(_useSetState, 2),
      state = _useSetState2[0],
      updateState = _useSetState2[1];

  var root = (0, _react().useRef)();
  var scrollParent = (0, _react().useRef)(null);
  var placeholder = (0, _react().useRef)();
  scrollParent.current = (0, _useScrollParent.default)(root); // 判断是否需要加载

  var check = /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2().default)( /*#__PURE__*/_regenerator().default.mark(function _callee() {
      var offset, direction, scrollParentRect, isReachEdge, placeholderRect;
      return _regenerator().default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (props.onLoad) {
                _context.next = 2;
                break;
              }

              return _context.abrupt("return");

            case 2:
              if (!(state.loading || props.finished || state.error)) {
                _context.next = 4;
                break;
              }

              return _context.abrupt("return");

            case 4:
              offset = props.offset, direction = props.direction;
              scrollParentRect = (0, _useRect.getRect)(scrollParent.current);

              if (!(!scrollParentRect.height || (0, _utils.isHidden)(root.current))) {
                _context.next = 8;
                break;
              }

              return _context.abrupt("return");

            case 8:
              isReachEdge = false;
              placeholderRect = (0, _useRect.getRect)(placeholder.current);

              if (direction === 'up') {
                isReachEdge = scrollParentRect.top - placeholderRect.top <= offset;
              } else {
                isReachEdge = placeholderRect.bottom - scrollParentRect.bottom <= offset;
              }

              if (!isReachEdge) {
                _context.next = 24;
                break;
              }

              _context.prev = 12;
              updateState({
                loading: true
              });

              if (!props.onLoad) {
                _context.next = 17;
                break;
              }

              _context.next = 17;
              return props.onLoad();

            case 17:
              updateState({
                loading: false
              });
              _context.next = 24;
              break;

            case 20:
              _context.prev = 20;
              _context.t0 = _context["catch"](12);
              // eslint-disable-next-line no-console
              console.warn('onLoad error:', _context.t0);
              updateState({
                loading: false,
                error: true
              });

            case 24:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[12, 20]]);
    }));

    return function check() {
      return _ref.apply(this, arguments);
    };
  }();

  var renderFinishedText = function renderFinishedText() {
    if (props.finished && props.finishedText) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('finished-text'))
      }, props.finishedText);
    }

    return null;
  };

  var clickErrorText = function clickErrorText() {
    updateState({
      error: false
    });
    check();
  };

  var renderErrorText = function renderErrorText() {
    if (state.error && props.errorText) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('error-text')),
        onClick: clickErrorText
      }, props.errorText);
    }

    return null;
  };

  var renderLoading = function renderLoading() {
    if (state.loading && !props.finished) {
      return /*#__PURE__*/_react().default.createElement("div", {
        className: (0, _classnames().default)(bem('loading'))
      }, /*#__PURE__*/(0, _react().isValidElement)(props.loadingText) ? props.loadingText : /*#__PURE__*/_react().default.createElement(_loading.default, {
        className: (0, _classnames().default)(bem('loading-icon')),
        size: 16
      }, props.loadingText));
    }

    return null;
  };

  (0, _hooks.useUpdateEffect)(function () {
    if (props.autoCheck) {
      check();
    }
  }, [state.loading, props.finished, props.error]);
  (0, _hooks.useUpdateEffect)(function () {
    updateState({
      loading: props.loading,
      error: props.error
    });
  }, [props.loading, props.error]);
  (0, _hooks.useUpdateEffect)(function () {
    if (scrollParent.current && props.immediateCheck) {
      check();
    }
  }, [scrollParent.current]);
  (0, _useEventListener.default)('scroll', check, {
    target: scrollParent.current,
    depends: [state.loading, props.finished, state.error]
  });
  (0, _react().useImperativeHandle)(ref, function () {
    return {
      check: check,
      state: state
    };
  });

  var Placeholder = /*#__PURE__*/_react().default.createElement("div", {
    ref: placeholder,
    className: (0, _classnames().default)(bem('placeholder'))
  });

  return /*#__PURE__*/_react().default.createElement("div", {
    ref: root,
    role: "feed",
    className: (0, _classnames().default)(bem()),
    "aria-busy": state.loading
  }, props.direction === 'down' ? props.children : Placeholder, renderLoading(), renderFinishedText(), renderErrorText(), props.direction === 'up' ? props.children : Placeholder);
});
List.defaultProps = {
  offset: 300,
  direction: 'down',
  immediateCheck: true,
  autoCheck: true,
  loadingText: '加载中...',
  finishedText: '没有更多了'
};
var _default = List;
exports.default = _default;