"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Notify = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _objectWithoutProperties2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

  _objectWithoutProperties2 = function _objectWithoutProperties2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _reactDom() {
  var data = _interopRequireDefault(require("react-dom"));

  _reactDom = function _reactDom() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _Notify = _interopRequireDefault(require("./Notify"));

var _getContainer = require("../utils/dom/getContainer");

var _lockClick = require("../toast/lock-click");

var _excluded = ["onClose", "duration"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var NotifyNamespace = {};

function parseOptions(message) {
  return (0, _utils.isObject)(message) ? message : {
    message: message
  };
}

var notifyArray = []; // 同步的销毁

function syncClear() {
  var fn = notifyArray.pop();

  while (fn) {
    fn();
    (0, _lockClick.lockClick)(false);
    fn = notifyArray.pop();
  }
} // 针对 toast 还没弹出来就立刻销毁的情况，将销毁放到下一个 event loop 中，避免销毁失败。


function nextTickClear() {
  setTimeout(syncClear);
} // 可返回用于销毁此弹窗的方法


var show = function show(p) {
  var props = parseOptions(p);

  var interProps = _objectSpread(_objectSpread({}, NotifyNamespace.currentOptions), props);

  var _interProps$onClose = interProps.onClose,
      onClose = _interProps$onClose === void 0 ? _utils.noop : _interProps$onClose,
      duration = interProps.duration,
      restProps = (0, _objectWithoutProperties2().default)(interProps, _excluded);
  var timer = 0;
  var userContainer = (0, _getContainer.resolveContainer)(props.teleport);
  var container = document.createElement('div');
  userContainer.appendChild(container);
  var destroy = _utils.noop;

  var TempNotify = function TempNotify() {
    var _useState = (0, _react().useState)(false),
        _useState2 = (0, _slicedToArray2().default)(_useState, 2),
        visible = _useState2[0],
        setVisible = _useState2[1];

    destroy = function destroy() {
      setVisible(false);
      if (onClose) onClose();
    }; // clearDOM after animation


    var internalOnClosed = function internalOnClosed() {
      var unmountResult = _reactDom().default.unmountComponentAtNode(container);

      if (unmountResult && container.parentNode) {
        container.parentNode.removeChild(container);
      }
    };

    var internalAfterClose = (0, _react().useCallback)((0, _utils.once)(function () {
      internalOnClosed();
    }), [onClose, container]);
    (0, _react().useEffect)(function () {
      setVisible(true);
      syncClear();
      notifyArray.push(internalAfterClose);

      if (duration && +duration > 0) {
        timer = window.setTimeout(destroy, duration);
      }

      return function () {
        if (timer !== 0) {
          window.clearTimeout(timer);
        }
      };
    }, []);
    return /*#__PURE__*/_react().default.createElement(_Notify.default, (0, _extends2().default)({}, restProps, {
      visible: visible,
      teleport: function teleport() {
        return container;
      },
      onClose: onClose,
      onClosed: internalOnClosed
    }));
  };

  _reactDom().default.render( /*#__PURE__*/_react().default.createElement(TempNotify, null), container);

  return destroy;
};

function defaultOptions() {
  return {
    type: 'danger',
    color: undefined,
    message: '',
    onClose: undefined,
    onClick: undefined,
    duration: 3000,
    className: '',
    lockScroll: false,
    background: undefined
  };
}

NotifyNamespace.currentOptions = defaultOptions();

var setDefaultOptions = function setDefaultOptions(options) {
  (0, _utils.extend)(NotifyNamespace.currentOptions, options);
};

var resetDefaultOptions = function resetDefaultOptions() {
  NotifyNamespace.currentOptions = defaultOptions();
};

var clear = nextTickClear;
var exportNotifyNamespace = Object.assign(_Notify.default, {
  show: show,
  setDefaultOptions: setDefaultOptions,
  resetDefaultOptions: resetDefaultOptions,
  clear: clear
});
exports.Notify = exportNotifyNamespace;
var _default = exportNotifyNamespace;
exports.default = _default;