"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _reactTransitionGroup() {
  var data = require("react-transition-group");

  _reactTransitionGroup = function _reactTransitionGroup() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _utils = require("../utils");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Overlay = function Overlay(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('overlay', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var nodeRef = (0, _react().useRef)(null);
  var visible = props.visible,
      duration = props.duration;

  var preventTouchMove = function preventTouchMove(event) {
    (0, _utils.preventDefault)(event, true);
  };

  var renderOverlay = function renderOverlay() {
    var style = _objectSpread(_objectSpread({
      zIndex: props.zIndex !== undefined ? +props.zIndex : undefined
    }, props.style), props.customStyle);

    if ((0, _utils.isDef)(duration)) {
      style.animationDuration = "".concat(duration, "ms");
    }

    return /*#__PURE__*/_react().default.createElement("div", {
      ref: nodeRef,
      style: style,
      onClick: props.onClick,
      className: (0, _classnames().default)(bem(), props.className),
      onTouchMove: props.lockScroll ? preventTouchMove : _utils.noop
    }, props.children);
  };

  return /*#__PURE__*/_react().default.createElement(_reactTransitionGroup().CSSTransition, {
    nodeRef: nodeRef,
    mountOnEnter: true,
    unmountOnExit: true,
    in: visible,
    timeout: duration,
    classNames: "rc-fade"
  }, renderOverlay());
};

Overlay.defaultProps = {
  lockScroll: true,
  duration: 300
};
var _default = Overlay;
exports.default = _default;