"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _extends2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

  _extends2 = function _extends2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _TabbarContext = _interopRequireDefault(require("./TabbarContext"));

var _icon = require("../icon");

var _badge = require("../badge");

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2().default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var TabbarItem = function TabbarItem(props) {
  var setActive = props.setActive,
      index = props.index;

  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('tabbar-item', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var _useContext2 = (0, _react().useContext)(_TabbarContext.default),
      parent = _useContext2.parent;

  var activeColor = parent.activeColor,
      inactiveColor = parent.inactiveColor;

  if (!parent) {
    if (process.env.NODE_ENV !== 'production') {
      console.error('[rc-ui-lib] <TabbarItem> must be a child component of <Tabbar>.');
    }
  }

  var active = (0, _react().useMemo)(function () {
    return (props.name || index) === parent.value;
  }, [props.name, index, parent.value]);

  var onClick = function onClick(event) {
    var _props$name, _props$onClick;

    setActive((_props$name = props.name) !== null && _props$name !== void 0 ? _props$name : index);
    (_props$onClick = props.onClick) === null || _props$onClick === void 0 ? void 0 : _props$onClick.call(props, event);
  };

  var renderIcon = function renderIcon() {
    if (typeof props.icon === 'string') {
      return /*#__PURE__*/_react().default.createElement(_icon.Icon, {
        name: props.icon,
        classPrefix: props.iconPrefix
      });
    }

    if (typeof props.icon === 'function') {
      return props.icon(active);
    }

    return null;
  };

  var color = active ? activeColor : inactiveColor;
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(props.className, bem({
      active: active
    })),
    style: _objectSpread(_objectSpread({}, props.style), {}, {
      color: color
    }),
    onClick: onClick
  }, /*#__PURE__*/_react().default.createElement(_badge.Badge, (0, _extends2().default)({}, props.badge, {
    className: (0, _classnames().default)(bem('icon'))
  }), renderIcon()), /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('text'))
  }, typeof props.children === 'function' ? props.children(active) : props.children));
};

var _default = TabbarItem;
exports.default = _default;