"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _react() {
  var data = _interopRequireWildcard(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _classnames() {
  var data = _interopRequireDefault(require("classnames"));

  _classnames = function _classnames() {
    return data;
  };

  return data;
}

var _swipe = _interopRequireDefault(require("../swipe"));

var _ConfigProviderContext = _interopRequireDefault(require("../config-provider/ConfigProviderContext"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var TabsContent = function TabsContent(props) {
  var _useContext = (0, _react().useContext)(_ConfigProviderContext.default),
      prefixCls = _useContext.prefixCls,
      createNamespace = _useContext.createNamespace;

  var _createNamespace = createNamespace('tabs', prefixCls),
      _createNamespace2 = (0, _slicedToArray2().default)(_createNamespace, 1),
      bem = _createNamespace2[0];

  var swipeRef = (0, _react().useRef)();
  var innerEffect = (0, _react().useRef)(false);
  var animated = props.animated,
      swipeable = props.swipeable,
      duration = props.duration;

  var renderChildren = function renderChildren() {
    if (animated || swipeable) {
      return /*#__PURE__*/_react().default.createElement(_swipe.default, {
        ref: swipeRef,
        loop: false,
        autoplay: false,
        allowTouchMove: swipeable,
        className: (0, _classnames().default)(bem('track')),
        duration: +duration,
        showIndicators: false,
        onChange: function onChange(idx) {
          if (innerEffect.current) {
            innerEffect.current = false;
            return;
          }

          if (props.onChange) props.onChange(idx);
        }
      }, _react().default.Children.map(props.children, function (child) {
        return /*#__PURE__*/_react().default.createElement(_swipe.default.Item, {
          role: "tabpanel",
          style: {
            cursor: !swipeable ? 'auto' : undefined
          },
          className: (0, _classnames().default)(bem('pane-wrapper'))
        }, child);
      }));
    }

    return props.children;
  };

  var swipeToCurrentTab = function swipeToCurrentTab(index) {
    var swipe = swipeRef.current;
    if (!swipe) return;

    if (swipe.activeIndex !== index) {
      innerEffect.current = true;
      swipe.slideTo(index, !props.inited ? 0 : +duration);
    }
  };

  (0, _react().useEffect)(function () {
    swipeToCurrentTab(props.currentIndex);
  }, [props.currentIndex]);
  return /*#__PURE__*/_react().default.createElement("div", {
    className: (0, _classnames().default)(bem('content', {
      animated: animated || swipeable
    }))
  }, renderChildren());
};

var _default = TabsContent;
exports.default = _default;