import React from 'react';
import { BaseTypeProps } from '../utils';
export declare type TypographyType = 'danger' | 'secondary' | 'light' | 'primary' | 'success' | 'warning';
export declare type TypographySize = 'xs' | 'sm' | 'md' | 'lg' | 'xl' | 'xxl';
export declare type TypographyTitleLevel = 1 | 2 | 3 | 4 | 5;
export interface TypographyBaseProps extends BaseTypeProps {
    type?: TypographyType;
    size?: TypographySize;
    level?: TypographyTitleLevel;
    disabled?: boolean;
    delete?: boolean;
    underline?: boolean;
    center?: boolean;
    strong?: boolean;
    ellipsis?: boolean | number;
    onClick?: (event: React.MouseEvent) => void;
    children?: React.ReactNode;
}
export declare type TypographyTextProps = Omit<TypographyBaseProps, 'level'>;
export declare type TypographyTitleProps = TypographyBaseProps;
export declare type TypographyLinkProps = Omit<TypographyBaseProps, 'level'>;
