"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isHidden = isHidden;

function isHidden(elementRef) {
  var el = elementRef;

  if (!el) {
    return false;
  }

  var style = window.getComputedStyle(el);
  var hidden = style.display === 'none'; // offsetParent returns null in the following situations:
  // 1. The element or its parent element has the display property set to none.
  // 2. The element has the position property set to fixed

  var parentHidden = el.offsetParent === null && style.position !== 'fixed';
  return hidden || parentHidden;
}